Browse Source

Errbit with Ansible

master
Blagovest Petrov 9 years ago
parent
commit
0154cf6d5a
  1. 0
      LICENSE
  2. 0
      README.md
  3. 0
      Vagrantfile
  4. 9
      errbit.yml
  5. 209
      files/errbit-init.sh
  6. 7
      files/nginx-errbit.conf
  7. 1
      infrastructure.yml
  8. 3
      roles/deploy.errbit/defaults/main.yml
  9. 5
      roles/deploy.errbit/handlers/main.yml
  10. 38
      roles/deploy.errbit/tasks/main.yml

0
LICENSE

0
README.md

0
Vagrantfile

9
errbit.yml

@ -0,0 +1,9 @@
- name: Errbit Deployment Script
hosts: errbit
sudo: yes
gather_facts: False
vars:
errbithome: /home/vagrant/errbit
githuburl: 'https://github.com/errbit/errbit.git'
roles:
- { role: deploy.errbit, mongo_passwd: '12345'}

209
files/errbit-init.sh

@ -0,0 +1,209 @@
#! /bin/sh
# Base on Gitlab. khairul@bukalapak.com
# GITLAB
# Maintainer: @randx
# Authors: rovanion.luckey@gmail.com, @randx
# App Version: 6.0
### BEGIN INIT INFO
# Provides: gitlab
# Required-Start: $local_fs $remote_fs $network $syslog redis-server
# Required-Stop: $local_fs $remote_fs $network $syslog
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: GitLab git repository management
# Description: GitLab git repository management
### END INIT INFO
### Environment variables
RAILS_ENV="production"
# Script variable names should be lower-case not to conflict with internal
# /bin/sh variables such as PATH, EDITOR or SHELL.
app_root="/home/errbit/errbit"
app_user="errbit"
unicorn_conf="$app_root/config/unicorn.rb"
pid_path="$app_root/tmp/pids"
socket_path="$app_root/tmp/sockets"
web_server_pid_path="$pid_path/unicorn.pid"
### Here ends user configuration ###
# Switch to the app_user if it is not he/she who is running the script.
if [ "$USER" != "$app_user" ]; then
sudo -u "$app_user" -H -i $0 "$@"; exit;
fi
# Switch to the errbit path, if it fails exit with an error.
if ! cd "$app_root" ; then
echo "Failed to cd into $app_root, exiting!"; exit 1
fi
### Init Script functions
check_pids(){
if ! mkdir -p "$pid_path"; then
echo "Could not create the path $pid_path needed to store the pids."
exit 1
fi
# If there exists a file which should hold the value of the Unicorn pid: read it.
if [ -f "$web_server_pid_path" ]; then
wpid=$(cat "$web_server_pid_path")
else
wpid=0
fi
}
# We use the pids in so many parts of the script it makes sense to always check them.
# Only after start() is run should the pids change. Sidekiq sets it's own pid.
check_pids
# Checks whether the different parts of the service are already running or not.
check_status(){
check_pids
# If the web server is running kill -0 $wpid returns true, or rather 0.
# Checks of *_status should only check for == 0 or != 0, never anything else.
if [ $wpid -ne 0 ]; then
kill -0 "$wpid" 2>/dev/null
web_status="$?"
else
web_status="-1"
fi
}
# Check for stale pids and remove them if necessary
check_stale_pids(){
check_status
# If there is a pid it is something else than 0, the service is running if
# *_status is == 0.
if [ "$wpid" != "0" -a "$web_status" != "0" ]; then
echo "Removing stale Unicorn web server pid. This is most likely caused by the web server crashing the last time it ran."
if ! rm "$web_server_pid_path"; then
echo "Unable to remove stale pid, exiting"
exit 1
fi
fi
}
# If no parts of the service is running, bail out.
exit_if_not_running(){
check_stale_pids
if [ "$web_status" != "0" ]; then
echo "Errbit is not running."
exit
fi
}
# Starts Unicorn
start() {
check_stale_pids
# Then check if the service is running. If it is: don't start again.
if [ "$web_status" = "0" ]; then
echo "The Unicorn web server already running with pid $wpid, not restarting."
else
echo "Starting the Errbit Unicorn web server..."
# Remove old socket if it exists
rm -f "$socket_path"/errbit.socket 2>/dev/null
# Start the webserver
bundle exec unicorn_rails -D -c "$unicorn_conf" -E "$RAILS_ENV"
fi
# Finally check the status to tell wether or not Errbit is running
status
}
# Asks the Unicorn if it would be so kind as to stop, if not kills them.
stop() {
exit_if_not_running
# If the Unicorn web server is running, tell it to stop;
if [ "$web_status" = "0" ]; then
kill -QUIT "$wpid" &
echo "Stopping the Errbit Unicorn web server..."
stopping=true
else
echo "The Unicorn web was not running, doing nothing."
fi
# If something needs to be stopped, lets wait for it to stop. Never use SIGKILL in a script.
while [ "$stopping" = "true" ]; do
sleep 1
check_status
if [ "$web_status" = "0" ]; then
printf "."
else
printf "\n"
break
fi
done
sleep 1
# Cleaning up unused pids
rm "$web_server_pid_path" 2>/dev/null
status
}
# Returns the status of GitLab and it's components
status() {
check_status
if [ "$web_status" != "0" ]; then
echo "Errbit is not running."
return
fi
if [ "$web_status" = "0" ]; then
echo "The Errbit Unicorn webserver with pid $wpid is running."
fi
}
reload(){
exit_if_not_running
if [ "$wpid" = "0" ];then
echo "The Errbit Unicorn Web server is not running thus its configuration can't be reloaded."
exit 1
fi
printf "Reloading Errbit Unicorn configuration... "
kill -USR2 "$wpid"
echo "Done."
sleep 2
status
}
restart(){
check_status
if [ "$web_status" = "0" ]; then
stop
fi
start
}
## Finally the input handling.
case "$1" in
start)
start
;;
stop)
stop
;;
restart)
restart
;;
reload|force-reload)
reload
;;
status)
status
;;
*)
echo "Usage: service errbit {start|stop|restart|reload|status}"
exit 1
;;
esac
exit

7
files/nginx-errbit.conf

@ -0,0 +1,7 @@
server {
listen 80;
server_name _;
location / {
proxy_pass http://127.0.0.1:3000;
}
}

1
infrastructure.yml

@ -0,0 +1 @@
- include: errbit.yml

3
roles/deploy.errbit/defaults/main.yml

@ -0,0 +1,3 @@
errbithome: '/home/vagrant/errbit'
githuburl: 'https://github.com/errbit/errbit.git'
mongo_passwd: "12345"

5
roles/deploy.errbit/handlers/main.yml

@ -0,0 +1,5 @@
- name: restart nginx
service:
name: mysql
state: restarted

38
roles/deploy.errbit/tasks/main.yml

@ -0,0 +1,38 @@
- name: GIT clone errbit repository
git: repo={{ githuburl }} dest={{ errbithome }}
- name: Install Bundler
command: /usr/bin/gem2.1 install bundler
- name: Bundle install
command: /usr/local/bin/bundle install
args:
chdir: '{{ errbithome }}'
register: bundleout
- debug: msg= '{{ bundleout.stdout }}'
- name: Bundle exec
command: /usr/local/bin/bundle exec rake errbit:bootstrap
args:
chdir: '{{ errbithome }}'
environment:
MONGO_URL: "mongodb://errbit:{{ mongo_passwd }}@127.0.0.1:27017/admin"
# register: dbing
#- debug: msg= '{{ dbing.stdout }}'
- name: Copy the init script
- copy: src=errbit-init.sh dest=/etc/init.d/errbit-init.sh owner=root group=root mode=0755
- name: Activate the init script
- command: /usr/sbin/update-rc.d -f errbit defaults
register: updatercdbg
-debug: msg = '{{ updatercdbg.stdout }}'
-name: Setup Nginx virtualhost
- copy: src=files/errbit-nginx.conf dest=/etc/nginx/sites-enabled/errbit.conf owner=root group=root mode=0755
- notify:
- restart nginx
Loading…
Cancel
Save